$(function () {
	function saveAndUpdate(){
		saveSetting(backgroundPage.loadSetting);
	}
	
	function limitInputNum(tar){
		var num = Number(tar.val());
		if(num > Number(tar.attr('max')))
			tar.val(tar.attr('max'));
		if(num < Number(tar.attr('min')))
			tar.val(tar.attr('min'));
		
	}
	
	loadSetting(function(){
		var treeData = [];

		for(var i = 0; i < options.panelOrder.length; i++){
			var node = {};
			
			var panelName = options.panelOrder[i];
			
			node.text = chrome.i18n.getMessage(panelName);

			node.icon = "../img/" + panelName + "16.png";
			treeData.push(node);
		}
		
		$('#theOrder').jstree({
		  "core" : {
			"check_callback" : function (operation, node, node_parent, node_position, more) {
				return node_parent.parent == null;
			},
			'data' : treeData
		  },

		  "plugins" : ["dnd"],
		  "dnd" : {

			}
		}).on('move_node.jstree', function (e, data) {
			var tmp = options.panelOrder.splice(data.old_position, 1);
			options.panelOrder.splice(data.position, 0, tmp[0]);
			saveAndUpdate();
        });
		
		var showNotifyChk = $('#showNotifyChk');
		var hideDownloadShelfChk = $('#hideDownloadShelfChk');
		var showDownloadNotifyChk = $('#showDownloadNotifyChk');
		var winWidthInput = $('#winWidthInput');
		var winHeightInput = $('#winHeightInput');
		
		
		showNotifyChk.prop("checked", options.showNotify);
		hideDownloadShelfChk.prop("checked", options.hideDownloadShelf);
		showDownloadNotifyChk.prop("checked", options.showDownloadNotify);
		
		winWidthInput.val(options.winWidth);
		winHeightInput.val(options.winHeight);
		
		showNotifyChk.change(function(){	
			options.showNotify = showNotifyChk.is(':checked');		
			saveAndUpdate();
		});
		
		hideDownloadShelfChk.change(function(){
			if(hideDownloadShelfChk.is(':checked')){
				options.hideDownloadShelf = true;
				
				showDownloadNotifyChk.prop("checked", true);
				options.showDownloadNotify = true;
				
				chrome.downloads.setShelfEnabled(false);
			}else{
				showDownloadNotifyChk.prop("checked", false);
				// options.showDownloadNotify = false;
				
				options.hideDownloadShelf = false;
				try {
					chrome.downloads.setShelfEnabled(true);
				}catch(err) {
				}
			}
			saveAndUpdate();
		});
		
		showDownloadNotifyChk.change(function(){	
			options.showDownloadNotify = showDownloadNotifyChk.is(':checked');	
			saveAndUpdate();
		});
		
		winWidthInput.change(function(){
			limitInputNum(winWidthInput);
			options.winWidth = winWidthInput.val();	
			saveAndUpdate();
		});
		winHeightInput.change(function(){	
			limitInputNum(winHeightInput);
			options.winHeight = winHeightInput.val();
			saveAndUpdate();
		});
		
	});
});