allPanels.tabs = new Panel(function(){
	var theTree = this.tree;
	var selfObj = this;
	var onRebuild = false;
	var curTabId = -1;
		
	this.middleAction = function(){
		toPage("chrome://newtab/");
	}
	
	function rebuildTree() {
		if(onRebuild) {
			clearTimeout(onRebuild); 
		}				
		onRebuild = setTimeout(function(){
			selfObj.tree.jstree("destroy");
			selfObj.updateTree(selfObj.oldKeyword);		
		}, 100);	
	}
	
	this.updateTree = function(keyword){
		if(curTabId === -1){
			chrome.tabs.query({currentWindow: true, active: true}, function(tabs){
				console.log(tabs);
				curTabId = tabs[0].id;
				selfObj.updateTree(keyword);
			});
			return;
		}
		
		keyword = keyword.toLowerCase().trim();
		
		var treeData = [];
					
		function drawTree(){	
			theTree.jstree({
				'core' : {
					'data' : treeData,
					"check_callback" : function (operation, node, node_parent, node_position, more) {

						return node.data.fixed !== true && typeof node_parent.data !== "undefined" && (
							(node_parent.data.type === "window" && node_parent.data.incognito === node.data.incognito) ||
							(node_parent.data.fixed === true && node.data.type === "tab")
							);
					},
				},
				"conditionalselect" : function (node, event) {
					if(event.which == 1){
						switch (node.data.type){
							case "newWin":
								chrome.windows.getCurrent(function(curWin){
									chrome.windows.create({state: curWin.state, focused: true});
									window.close();
								});
								break;	

								
							case "newIncognito":
								chrome.windows.getCurrent(function(curWin){
									chrome.windows.create({state: curWin.state,incognito: true, focused: true});
									window.close();
								});
								break;
							
							case "tab":
								chrome.tabs.update(node.data.id, {active: true});
								
								chrome.windows.update(node.data.parentId, {focused: true}, function(){
									window.close();
								});
								break;
								
							case "link":
								toPage(node.data.url);
								break;
								
							case "mergeWins":
							chrome.windows.getCurrent(null, function(curWin) {
								chrome.windows.getAll({populate: true}, function(windows) {
									var diffIncognitoWin = null;
									
									for (var i = 0; i < windows.length; i++) {
										if (windows[i].id !== curWin.id) {
											if(windows[i].incognito === curWin.incognito){
												for (var j = 0; j < windows[i].tabs.length; j++) {
													chrome.tabs.move(windows[i].tabs[j].id, {windowId: curWin.id, 'index': -1});
												}												
											}else if(diffIncognitoWin === null){
												diffIncognitoWin = windows[i].id;
											}else{
												for (var j = 0; j < windows[i].tabs.length; j++) {
													chrome.tabs.move(windows[i].tabs[j].id, {windowId: diffIncognitoWin, 'index': -1});
												}													 
											}
										}
									}
									rebuildTree();									
								});
							});								
							break;
							case "closedTab":
							case "closedWin":
								chrome.sessions.restore(node.data.id, function(){
									window.close();
								});
							break;
						}
						
						this.toggle_node(node);						
					}
					return false;
				},
				"contextmenu": {
					"items": function (node) {
						if(node.data.fixed === true) return{};

						if(node.data.type === "tab") return {
							"move2NewWin": {
								"label": chrome.i18n.getMessage("move_to_new_win"),
								"action": function (obj) {
									chrome.windows.getCurrent(function(curWin){
										chrome.windows.create({incognito: node.data.incognito, tabId: node.data.id, state: curWin.state, focused: true, incognito: curWin.incognito},
											function(theWindow){
												window.close();
											}
										);
									});										
								}
							},
							"closeAbove": {
								"label": chrome.i18n.getMessage("close_above"),
								"action": function (obj) {
									
									chrome.windows.get(node.data.parentId, {populate: true}, function(win){
										
										for(var i = 0; i < win.tabs.length; i++){
											if(win.tabs[i].id === node.data.id) break;
											chrome.tabs.remove(win.tabs[i].id);
										}
									});
								}
							},
							"closeBelow": {
								"label": chrome.i18n.getMessage("close_below"),
								"action": function (obj) {
									
									chrome.windows.get(node.data.parentId, {populate: true}, function(win){
										var i;
										for(i = 0; win.tabs[i].id !== node.data.id; i++){}
										for(i++; i < win.tabs.length; i++){
											chrome.tabs.remove(win.tabs[i].id);
										}										
									});
								}
							},
							"close": {
								"label": chrome.i18n.getMessage("close"),
								"action": function (obj) {
									chrome.tabs.remove(node.data.id);
								},
								"separator_after": true
							},
							"copyTitle": {
								"label": chrome.i18n.getMessage("copy_title"),
								"action": function (obj) {
									prompt(chrome.i18n.getMessage("copy_hint"), node.data.oriText);
								}
							},
							"copyUrl": {
								"label": chrome.i18n.getMessage("copy_url"),
								"action": function (obj) {
									prompt(chrome.i18n.getMessage("copy_hint"), node.data.url);
								}
							}
						};
						if(node.data.type === "window") return {
							"close": {
								"label": chrome.i18n.getMessage("close"),
								"action": function (obj) {
									chrome.windows.remove(node.data.id);
								}
							}	
						};
						if(node.data.type === "closedTab") return {
							"copyTitle": {
								"label": chrome.i18n.getMessage("copy_title"),
								"action": function (obj) {
									prompt(chrome.i18n.getMessage("copy_hint"), node.data.oriText);
								}
							},
							"copyUrl": {
								"label": chrome.i18n.getMessage("copy_url"),
								"action": function (obj) {
									prompt(chrome.i18n.getMessage("copy_hint"), node.data.url);
								}
							}
						};						
						
						
					}
				},	
				"plugins": ["conditionalselect", "dnd", "contextmenu"]
				
			});				
		}

		chrome.windows.getAll({populate: true}, function(allWins) {
			//add newWin
			treeData.push({
				text: chrome.i18n.getMessage("newWin"),
				data: {type: "newWin", fixed: true},
				icon: "../img/newWin16.png"
			});
			
			//add newIncognito
			treeData.push({
				text: chrome.i18n.getMessage("newIncognito"),
				data: {type: "newIncognito", fixed: true},
				icon: "../img/newIncognito16.png"
			});
			
			
			//add mergeWins
			treeData.push({
				text: chrome.i18n.getMessage("mergeWins"),
				data: {type: "mergeWins", fixed: true},
				icon: "../img/mergeWins16.png"
			});

			for(var i = 0; i < allWins.length; i++){
				//console.log(allWins[i]);
				var tabs = allWins[i].tabs;				
				var windowNode = {
					text: tabs.length + " " + chrome.i18n.getMessage("tabs") + 
						  (allWins[i].incognito ? ("(" + chrome.i18n.getMessage("incognito") + ")") : "" ),
					icon: allWins[i].incognito ? "../img/incognito16.png" : "../img/tabs16.png",
					children:[],
					data: {
						type: 'window',
						id: allWins[i].id,
						incognito: allWins[i].incognito
					},
					state: {"opened" : true}				
				};
				
				for(var j = 0; j < tabs.length; j++){

					var tabNode = {						
						text: tabs[j].title.escapeHtml(),
						icon: "chrome://favicon/size/16@1x/" + tabs[j].url,
						data: {
							type: 'tab',
							id: tabs[j].id,
							url: tabs[j].url,
							parentId: allWins[i].id,
							incognito: allWins[i].incognito,
							oriText: tabs[j].title,
							showTooltip: tabs[j].title.byteLen() > 25
						}
					};
					

					if(curTabId == tabs[j].id){
						tabNode.text = '<label class = "highlight">' + tabNode.text + '</label>';
					}
					
					
					if(keyword != "" && tabs[j].title.toLowerCase().indexOf(keyword) == -1
								     && tabs[j].url.toLowerCase().indexOf(keyword) == -1){
						continue; //do not add
					}
					windowNode.children.push(tabNode);
				}
				if(windowNode.children.length > 0) treeData.push(windowNode);
			}
			

			chrome.sessions.getRecentlyClosed({}, function (sessions){
				var tabChildNodes = [];
				var winChildNodes = [];

				//console.log(sessions);
				
				for(var i = 0; i < sessions.length; i++){
					if(typeof sessions[i].tab !== "undefined"){
						var theTab = sessions[i].tab;
						
						if(keyword != "" && theTab.title.toLowerCase().indexOf(keyword) == -1
										 && theTab.url.toLowerCase().indexOf(keyword) == -1){
							continue; //do not add
						}
						tabChildNodes.push({
							text: theTab.title.escapeHtml(),
							icon: "chrome://favicon/size/16@1x/" + theTab.url,
							data: {
								type: 'closedTab',
								id: theTab.sessionId,
								url: theTab.url,
								oriText: theTab.title,
								showTooltip: theTab.title.byteLen() > 25
							}					
						});

					}else{ //is a window
						var theWin = sessions[i].window;
						winChildNodes.push({
							text: theWin.tabs.length + " " + chrome.i18n.getMessage("tabs") + " (" + 
								  getElapsedText(Date.now() - sessions[i].lastModified * 1000) + chrome.i18n.getMessage("ago") + ")",
							icon: "../img/newWin16.png",
							data: {
								type: 'closedWin',
								id: theWin.sessionId
							}					
						});							
					}
				}
				
				if(tabChildNodes.length > 0){
					//add closed tabs
					treeData.push({
						text: chrome.i18n.getMessage("closedTabs"),
						data: {type: "folder", fixed: true},
						icon: "../img/closed16.png",
						state: {"opened" : true},
						children: tabChildNodes
					});					
				}				
				
				if(winChildNodes.length > 0){
					//add closed windows
					treeData.push({
						text: chrome.i18n.getMessage("closedWins"),
						data: {type: "folder", fixed: true},
						icon: "../img/closeWin16.png",
						state: {"opened" : true},
						children: winChildNodes
					});					
				}
				
				//add setting link
				treeData.push({
					text: chrome.i18n.getMessage("setting"),
					data: {url: "chrome://settings/", type: "link", fixed: true},
					icon: "chrome://favicon/size/16@1x/chrome://settings/"
				});	
				drawTree();				
			});
			

		});
	}
	
	theTree.on("click auxclick", '.jstree-anchor', function(e) {
		if(e.which == 2){ //mouse middle button
			e.preventDefault(); 
			var node = theTree.jstree(true).get_node(e.target);
			
			switch (node.data.type){
				case "window":
					chrome.windows.remove(node.data.id);
				case "tab":
					chrome.tabs.remove(node.data.id);
					break;
				case "link":
					chrome.tabs.create({url: node.data.url, selected: false});
					break;
				
			}
		}
	}).on('move_node.jstree', function (e, data) {
		var parentData = theTree.jstree(true).get_node(data.parent).data;
		var nodeData = data.node.data;
		
		if(nodeData.type === "tab"){
			if(parentData.fixed === true){
				chrome.windows.getCurrent(function(curWin){
					chrome.windows.create({incognito: nodeData.incognito, tabId: nodeData.id, state: curWin.state, focused: true, incognito: curWin.incognito},
						function(theWindow){
							window.close();
						}
					);
				});					
			}else{
				var parentId = parentData.id;
				var position = data.position;
				
				//handle order move shift
				if(data.parent === data.old_parent && position > data.old_position){
					position++;
				}
				
				chrome.tabs.move(nodeData.id, {windowId: parentId, index: position}, function(){
					rebuildTree();
				});				
			}
		}else if(nodeData.type === "window"){
			if(parentData.fixed !== true){
				chrome.windows.get(nodeData.id, {populate: true}, function (thisWindow){
					var moveCount = 0;
					for (var j = 0; j < thisWindow.tabs.length; j++) {
						chrome.tabs.move(thisWindow.tabs[j].id, {windowId: parentData.id, 'index': -1}, function(){
							moveCount++;
							if(moveCount === thisWindow.tabs.length){
								rebuildTree();
							}
						});
					}
					
				});
			}
		}
		
	}).on('hover_node.jstree', addTooltip);
	
	
	
/*	
	theTree.on('contextmenu', '.jstree-anchor', function (e) {
		e.preventDefault();  //disable contextmenu
	});
*/	
	chrome.tabs.onUpdated.addListener(rebuildTree);
	chrome.tabs.onRemoved.addListener(rebuildTree);
	
});